<?php

/*
  eShox OS
  http://www.eshox.com/
  
  Copyright (c) 2003, Secure.cc, Inc.

*/

return true;

class mime {
	var $_encoding;
	var $_subparts;
	var $_encoded;
	var $_headers;
	var $_body;

	function mime($body, $params = '') {
		if ($params == '') {
			$params = array();
		}
	 
		$this->lf = UNIX_RETURN;
		foreach ($params as $key => $value) {
			switch ($key) {
				case 'content_type':
					$headers['Content-Type'] = $value . (isset($charset) ? '; charset="' . $charset . '"' : '');
					break;
				case 'encoding':
					$this->_encoding = $value;
					$headers['Content-Transfer-Encoding'] = $value;
					break;
				case 'cid':
					$headers['Content-ID'] = '<' . $value . '>';
					break;
				case 'disposition':
					$headers['Content-Disposition'] = $value . (isset($dfilename) ? '; filename="' . $dfilename . '"' : '');
					break;
				case 'dfilename':
					if (isset($headers['Content-Disposition'])) {
						$headers['Content-Disposition'] .= '; filename="' . $value . '"';
					} else {
						$dfilename = $value;
					}
					break;
				case 'description':
					$headers['Content-Description'] = $value;
					break;
				case 'charset':
					if (isset($headers['Content-Type'])) {
						$headers['Content-Type'] .= '; charset="' . $value . '"';
					} else {
						$charset = $value;
					}
					break;
			}
		}
	 
		if (!isset($_headers['Content-Type'])) {
			$_headers['Content-Type'] = 'text/plain';
		}

	 
		$this->_encoded  =  array();
		$this->_headers  =& $headers;
		$this->_body     =  $body;
	}

	function encode() {
		$encoded =& $this->_encoded;

		if (!empty($this->_subparts)) {
			srand((double)microtime()*1000000);
			$boundary = md5(uniqid(rand()) . microtime());
	        $this->_headers['Content-Type'] .= '; boundary="' . $boundary . '"';
		 
			for ($i = 0; $i < count($this->_subparts); $i++) {
				$headers = array();
				$tmp = $this->_subparts[$i]->encode();
				foreach ($tmp['headers'] as $key => $value) {
					$headers[] = $key . ': ' . $value;
				}
				$subparts[] = implode($this->lf, $headers) . $this->lf . $this->lf . $tmp['body'];
			}

			$encoded['body'] = '--' . $boundary . $this->lf . implode('--' . $boundary . $this->lf, $subparts) . '--' . $boundary.'--' . $this->lf;
		} else {
			$encoded['body'] = $this->_getEncodedData($this->_body, $this->_encoding) . $this->lf;
		}

	 
		$encoded['headers'] =& $this->_headers;

		return $encoded;
	}

	function &addSubPart($body, $params) {
		$this->_subparts[] = new mime($body, $params);
		return $this->_subparts[count($this->_subparts) - 1];
	}

	function _getEncodedData($data, $encoding) {
		switch ($encoding) {
		 case '7bit':
			 return $data;
			 break;
		 case 'quoted-printable':
			 return $this->_quotedPrintableEncode($data);
			 break;
		 case 'base64':
			 return rtrim(chunk_split(base64_encode($data), 76, $this->lf));
			 break;
		}
	}

	function _quotedPrintableEncode($input , $line_max = 76) {
		$lines    = preg_split("/\r\n|\r|\n/", $input);
		$eol    = $this->lf;
		$escape    = '=';
		$output    = '';
		while(list(, $line) = each($lines)){
			$linlen     = strlen($line);
			$newline = '';
			for ($i = 0; $i < $linlen; $i++) {
				$char = substr($line, $i, 1);
				$dec  = ord($char);
				if (($dec == 32) AND ($i == ($linlen - 1))){   
					$char = '=20';
				} elseif($dec == 9) {
					;
				} elseif(($dec == 61) OR ($dec < 32 ) OR ($dec > 126)) {
					$char = $escape . strtoupper(sprintf('%02s', dechex($dec)));
				}
			 
				if ((strlen($newline) + strlen($char)) >= $line_max) {
				 
					$output  .= $newline . $escape . $eol;
					$newline  = '';
				}
				$newline .= $char;
			}
			$output .= $newline . $eol;
		}
	 
		$output = substr($output, 0, -1 * strlen($eol));
		return $output;
	}
}

class Email {
  var $html;
  var $text;
  var $output;
  var $html_text;
  var $html_images;
  var $image_types;
  var $build_params;
  var $attachments;
  var $headers;

  function Email($headers = array()) {

	$this->html_images  = array();
	$this->headers      = array();

	$this->lf = UNIX_RETURN;
	$this->image_types = array(
	  'gif'  => 'image/gif',
	  'jpg'  => 'image/jpeg',
	  'jpeg' => 'image/jpeg',
	  'jpe'  => 'image/jpeg',
	  'bmp'  => 'image/bmp',
	  'png'  => 'image/png',
	  'tif'  => 'image/tiff',
	  'tiff' => 'image/tiff',
	  'swf'  => 'application/x-shockwave-flash'
	);

	$this->build_params['html_encoding']  = '7bit';
	$this->build_params['text_encoding']  = '7bit';
	$this->build_params['html_charset']    = 'utf-8';
	$this->build_params['text_charset']    = 'utf-8';
	$this->build_params['text_wrap']    = 998;

	$this->headers[] = 'MIME-Version: 1.0';

	reset($headers);
	foreach ($headers as $value) {
	  if(!empty($value))
	    $this->headers[] = $value;
	}
  }

  function get_file($filename) {

	$return = '';
	if($fp = fopen($filename, 'rb')) {
	  while(!feof($fp)) {
	    $return .= fread($fp, 1024);
	  }
	  fclose($fp);
	  return $return;

	} else {
	  return FALSE;
	}
  }

  function find_html_images($images_dir) {

	// Build the list of image extensions
	while(list($key,) = each($this->image_types))
	  $extensions[] = $key;

	preg_match_all('/"([^"]+\.('.implode('|', $extensions).'))"/Ui', $this->html, $images);

	for($i=0; $i<count($images[1]); $i++) {
	  if(file_exists($images_dir.$images[1][$i])) {
	    $html_images[] = $images[1][$i];
	    $this->html = str_replace($images[1][$i], basename($images[1][$i]), $this->html);
	  }
	}

	if(!empty($html_images)) {

	  // If duplicate images are embedded, they may show up as attachments, so remove them.
	  $html_images = array_unique($html_images);
	  sort($html_images);
  
	  for($i=0; $i<count($html_images); $i++) {
	    if($image = $this->get_file($images_dir.$html_images[$i])) {
	      $content_type = $this->image_types[substr($html_images[$i], strrpos($html_images[$i], '.') + 1)];
	      $this->add_html_image($image, basename($html_images[$i]), $content_type);
	    }
	  }
	}
  }

  function add_text($text = '') {
	$this->text = $text;
  }

  function add_html($html, $text = NULL, $images_dir = NULL) {
	$this->html       = $html;
	$this->html_text  = $text;
	if(isset($images_dir))
	  $this->find_html_images($images_dir);
  }

  function add_html_image($file, $name = '', $c_type='application/octet-stream') {
	$this->html_images[] = array(
	                              'body'   => $file,
	                              'name'   => $name,
	                              'c_type' => $c_type,
	                              'cid'    => md5(uniqid(time()))
	                            );
  }

  function add_attachment($file, $name = '', $c_type='application/octet-stream', $encoding = 'base64') {
	$this->attachments[] = array(
	                              'body'    => $file,
	                              'name'    => $name,
	                              'c_type'  => $c_type,
	                              'encoding'  => $encoding
	                            );
  }

  function &add_text_part(&$obj, $text) {
	$params['content_type'] = 'text/plain';
	$params['encoding']     = $this->build_params['text_encoding'];
	$params['charset']      = $this->build_params['text_charset'];
	if(is_object($obj)) {
	  return $obj->addSubpart($text, $params);
	} else {
	  return new mime($text, $params);
	}
  }

  function &add_html_part(&$obj) {
	$params['content_type'] = 'text/html';
	$params['encoding']     = $this->build_params['html_encoding'];
	$params['charset']      = $this->build_params['html_charset'];
	if(is_object($obj)) {
	  return $obj->addSubpart($this->html, $params);
	} else {
	  return new mime($this->html, $params);
	}
  }

  function &add_mixed_part() {

	$params['content_type'] = 'multipart/mixed';
	return new mime('', $params);
  }

  function &add_alternative_part(&$obj) {

	$params['content_type'] = 'multipart/alternative';
	if(is_object($obj)) {
	  return $obj->addSubpart('', $params);
	} else {
	  return new mime('', $params);
	}
  }

  function &add_related_part(&$obj) {
	$params['content_type'] = 'multipart/related';
	if(is_object($obj)) {
	  return $obj->addSubpart('', $params);
	} else {
	  return new mime('', $params);
	}
  }

  function &add_html_image_part(&$obj, $value) {
	$params['content_type'] = $value['c_type'];
	$params['encoding']     = 'base64';
	$params['disposition']  = 'inline';
	$params['dfilename']    = $value['name'];
	$params['cid']          = $value['cid'];
	$obj->addSubpart($value['body'], $params);
  }

  function &add_attachment_part(&$obj, $value) {
	$params['content_type'] = $value['c_type'];
	$params['encoding']     = $value['encoding'];
	$params['disposition']  = 'attachment';
	$params['dfilename']    = $value['name'];
	$obj->addSubpart($value['body'], $params);
  }

  function build_message($params = array()) {
	if(count($params) > 0) {
	  reset($params);
	  while(list($key, $value) = each($params)) {
	    $this->build_params[$key] = $value;
	  }
	}
	if (!empty($this->html_images)) {
	  reset($this->html_images);
	  foreach ($this->html_images as $value) {
	    $this->html = str_replace($value['name'], 'cid:'.$value['cid'], $this->html);
	  }
	}

	$null        = NULL;
	$attachments = !empty($this->attachments) ? TRUE : FALSE;
	$html_images = !empty($this->html_images) ? TRUE : FALSE;
	$html        = !empty($this->html)        ? TRUE : FALSE;
	$text        = isset($this->text)         ? TRUE : FALSE;

	switch(TRUE) {

	  case $text AND !$attachments:
	    $message =& $this->add_text_part($null, $this->text);
	    break;

	  case !$text AND $attachments AND !$html:
	    $message =& $this->add_mixed_part();

	    for($i=0; $i<count($this->attachments); $i++)
	      $this->add_attachment_part($message, $this->attachments[$i]);
	    break;

	  case $text AND $attachments:
	    $message =& $this->add_mixed_part();
	    $this->add_text_part($message, $this->text);

	    for($i=0; $i<count($this->attachments); $i++)
	      $this->add_attachment_part($message, $this->attachments[$i]);
	    break;

	  case $html AND !$attachments AND !$html_images:
	    if(!is_null($this->html_text)) {
	      $message =& $this->add_alternative_part($null);
	      $this->add_text_part($message, $this->html_text);
	      $this->add_html_part($message);
	    } else {
	      $message =& $this->add_html_part($null);
	    }
	    break;

	  case $html AND !$attachments AND $html_images:
	    if(!is_null($this->html_text)) {
	      $message =& $this->add_alternative_part($null);
	      $this->add_text_part($message, $this->html_text);
	      $related =& $this->add_related_part($message);
	    } else {
	      $message =& $this->add_related_part($null);
	      $related =& $message;
	    }
	    $this->add_html_part($related);
	    for($i=0; $i<count($this->html_images); $i++)
	      $this->add_html_image_part($related, $this->html_images[$i]);
	    break;

	  case $html AND $attachments AND !$html_images:
	    $message =& $this->add_mixed_part();
	    if(!is_null($this->html_text)) {
	      $alt =& $this->add_alternative_part($message);
	      $this->add_text_part($alt, $this->html_text);
	      $this->add_html_part($alt);
	    } else {
	      $this->add_html_part($message);
	    }
	    for($i=0; $i<count($this->attachments); $i++)
	      $this->add_attachment_part($message, $this->attachments[$i]);
	    break;

	  case $html AND $attachments AND $html_images:
	    $message =& $this->add_mixed_part();
	    if(!is_null($this->html_text)) {
	      $alt =& $this->add_alternative_part($message);
	      $this->add_text_part($alt, $this->html_text);
	      $rel =& $this->add_related_part($alt);
	    } else {
	      $rel =& $this->add_related_part($message);
	    }
	    $this->add_html_part($rel);
	    for($i=0; $i<count($this->html_images); $i++)
	      $this->add_html_image_part($rel, $this->html_images[$i]);
	    for($i=0; $i<count($this->attachments); $i++)
	      $this->add_attachment_part($message, $this->attachments[$i]);
	    break;

	}

	if(isset($message)) {
	  $output = $message->encode();
	  $this->output = $output['body'];
	  foreach ($output['headers'] as $key => $value) {
	    $headers[] = $key.': '.$value;
	  }

	  $this->headers = array_merge($this->headers, $headers);
	  return TRUE;
	} else {
	  return FALSE;
	}
  }
  
  function mail_response($fp) {
	while (substr($response, 3, 1) != ' ') {
		$response = fgets($fp, 256);
	}
	return $response . DOS_RETURN;
  }

  function sendmail($to_name, $to_addr, $from_name, $from_addr, $subject = '', $headers = '') {
	$to    = ($to_name != '')   ? '"'.$to_name.'" <'.$to_addr.'>' : $to_addr;
	$from  = ($from_name != '') ? '"'.$from_name.'" <'.$from_addr.'>' : $from_addr;
	$message = "Date: " . date('D, d M Y H:m:s O') . "
From: " . $from . "
" . $headers . "
" . $this->output . "
";

	if (MAIL_SERVICE == 'SMTP') {
	  $mail_servers = explode(',',MAIL_SERVER_ADDR);
	  while ($address = each($mail_servers)) {
	    $address_array = split("[:#]" , $address[1]);
	    if (sizeof($address_array) > 1) {
	      $smtp_user = $address_array[0];
	      $smtp_password = $address_array[1];
	      $smtp_server = $address_array[2];
	    } else {
	      $smtp_user = false;
	      $smtp_password = false;
	      $smtp_server = $address[1];
	    }
	    if ($fp = fsockopen ($smtp_server, 25, $errno, $errstr, 15)) {
	      $smtp_error = false;
	      break;
	    }
	    else $smtp_error = true;
	  }
    
    if (!$smtp_error) {
      if ($smtp_user) {
        fputs ($fp, "EHLO " . HOST . DOS_RETURN);
        #if (!stream_set_timeout($fp, 2)) die('EHLO failed');
        $response .= $this->mail_response($fp);
        
        fputs ($fp, "AUTH LOGIN" . DOS_RETURN);
        $response .= $this->mail_response($fp);
        
        fputs ($fp, base64_encode($smtp_user) . DOS_RETURN);
        $response .= $this->mail_response($fp);
        
        fputs ($fp, base64_encode($smtp_password) . DOS_RETURN);
        $response .= $this->mail_response($fp);
      } else {
        fputs ($fp, "HELO " . HOST . DOS_RETURN);
        $response .= $this->mail_response($fp);
      }
      
      fputs ($fp, "MAIL FROM: <" . trim($from_addr) . ">" . DOS_RETURN);
      $response .= $this->mail_response($fp);
      
      fputs ($fp, "RCPT TO: <" . trim($to_addr) . ">" . DOS_RETURN);
      $response .= $this->mail_response($fp);
      
      fputs ($fp, "DATA" . DOS_RETURN);
      $response .= $this->mail_response($fp);
      
      fputs ($fp, "Subject: " . $subject . DOS_RETURN . "To: " . $to . DOS_RETURN . $message);
      
      fputs ($fp, DOS_RETURN . '.' . DOS_RETURN);
      $response .= $this->mail_response($fp);
      
      fputs ($fp, "QUIT" . DOS_RETURN);
      $response .= $this->mail_response($fp);
      
      fclose ($fp);
    }
    // smtp error
    else {	  
      // use sendmail to email customer and store owner
      $usermail = mail($to, $subject, '', $message, '-f' . STORE_OWNER_EMAIL_ADDRESS);
      $adminmail = mail('"' . STORE_OWNER . '" <' . STORE_OWNER_EMAIL_ADDRESS . '>', HOST . ' eShox store email settings', 'Your store at ' . WEB_SERVER_ADDRESS . ' is currentlly NOT sending emails due to an SMTP settings error. The message was successfully sent using sendmail.  Please check your settings.', "From: \"" . STORE_OWNER . "\" <" . STORE_OWNER_EMAIL_ADDRESS . ">\r\nX-Mailer: " . WEB_SERVER_ADDRESS, '-f' . STORE_OWNER_EMAIL_ADDRESS);
      if (!$usermail && !$adminmail) die('ERROR: SMTP and Sendmail emails are unavailable, please contact the store owner with this message.');
    }
	  
	} else {
	  mail($to, $subject, '', $message, '-f' . STORE_OWNER_EMAIL_ADDRESS);
	}
  }
}
