<?php
/*
	eShox OS
	http://www.eshox.com/

	Copyright (c) 2003, Secure.cc, Inc.

	Released under the GNU General Public License

*/

  class ot_tax {
	var $title, $output;

	function ot_tax() {
	  $this->code = 'ot_tax';
	  $this->title = MODULE_ORDER_TOTAL_TAX_TITLE;
	  $this->description = 'Tax Options:';
	  $this->enabled = defined('MODULE_ORDER_TOTAL_TAX_STATUS');
	  $this->sort_order = 4;

	  $this->output = array();
	}

	function process() {
	  global $order;
	  
	  if ($_SESSION['customers_resale_number']) return false;
	  
	  if (MODULE_ORDER_TOTAL_TAX_SHOW_GROUPS == 'true') {
	    reset($order->info['tax_groups']);
	    while (list($key, $value) = each($order->info['tax_groups'])) {
	      if ($value > 0) {
	      $this->output[] = array('title' => $this->title . ' (' . $key . '%):',
	                              'text' => $GLOBALS['currencies']->format($value, true, $order->info['currency'], $order->info['currency_value']),
	                              'value' => $value);
	      }
	    }
	  } else {
	    if ($order->info['tax'] > 0) {
	    $this->output[] = array('title' => $this->title . ':',
	                            'text' => $GLOBALS['currencies']->format($order->info['tax'], true, $order->info['currency'], $order->info['currency_value']),
	                            'value' => $order->info['tax']);
	    }
	  }
	}

	function check() {
	  return defined('MODULE_ORDER_TOTAL_TAX_STATUS');
	}

	function keys() {
	  return array('MODULE_ORDER_TOTAL_TAX_STATUS', 'MODULE_ORDER_TOTAL_TAX_ADDRESS_BOOK_ID', 'MODULE_ORDER_TOTAL_TAX_SHOW_GROUPS');
	}

	function install() {
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_key, configuration_value) values ('MODULE_ORDER_TOTAL_TAX_STATUS', 'true')");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Customers Tax Location', 'MODULE_ORDER_TOTAL_TAX_ADDRESS_BOOK_ID', 'Billing', 'Which address should be used for tax calculations?', '6', '1', 'shop_cfg_select_option(array(\'Billing\', \'Shipping\'), ', now())");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Display Tax Groups', 'MODULE_ORDER_TOTAL_TAX_SHOW_GROUPS', 'false', 'Display tax groups at checkout?', '6', '2', 'shop_cfg_checkbox_display(', 'shop_cfg_checkbox(', now())");
	}

	function remove() {
	  shop_db_query("delete from " . DB_PREFIX . "configuration where configuration_key in ('" . implode("','", $this->keys()) . "')");
	}
  }
