<?php

/*
  eShox 3 Commerce Solution
  http://www.eshox.com/
  
  Copyright (c) 2003, Secure.cc, Inc.

*/

class beanstream {
	var $code, $title, $description, $enabled;

	function beanstream() {
	  $this->code = 'beanstream';
	  $this->title = 'Beanstream';
	  $this->shop_title = MODULE_PAYMENT_CC_TEXT_TITLE;
	  $this->description = '';
	  $this->signup = 'https://www.beanstream.com/website/merchant_services/application_form/apply.asp';
	  $this->enabled = defined('MODULE_PAYMENT_BEANSTREAM_STATUS');
	  $this->recommend_level = 0;
	  $this->version = "1.0";
	}

	function javascript_validation() {
	  return shop_draw_cc_javascript_validation($this->code);
	}

	function selection() {
	  return shop_draw_cc_input();
	}

	function pre_confirmation_check() {
	  if ($_POST['payment_selected'] == $this->code) shop_validate_cc($_POST['cc_owner'],$_POST['cc_number'], $_POST['cc_expires_month'], $_POST['cc_expires_year'], $_POST['cc_code']);
	}

	function confirmation() {
	}

	function process_button() {
	  $process_button_string = shop_draw_hidden_field('cc_owner', $_POST['cc_owner']) . 
	                           shop_draw_hidden_field('cc_number', $_POST['cc_number']) . 
	                           shop_draw_hidden_field('cc_code', $_POST['cc_code']) . UNIX_RETURN .
	                           shop_draw_hidden_field('cc_expires', $_POST['cc_expires_month'] . substr($_POST['cc_expires_year'], -2)) . UNIX_RETURN;

	  return $process_button_string;
	}
	
	function get_country_code($country) {
		$query = shop_db_query("select countries_iso_code_2 from " . DB_PREFIX . "countries where countries_name = '$country'");
		$country = shop_db_fetch_array($query);
		return $country['countries_iso_code_2'];
	}
	
	function get_zone_code($zone) {
		$query = shop_db_query("select zone_code from " . DB_PREFIX . "zones where zone_name = '$zone'");
		$zone = shop_db_fetch_array($query);
		return $zone['zone_code'];
	}
	
	function before_process() {
		global $order;
		
		$cc_owner = strrev($_POST['cc_owner']);
		$cc_owner_firstname = strrev(substr($cc_owner, strpos($cc_owner, ' ')+1));
		$cc_owner_lastname =strrev( substr($cc_owner, 0, strpos($cc_owner, ' ')));

		$data_array = array('requestType' => 'BACKEND',
							'merchant_id' => MODULE_PAYMENT_BEANSTREAM_MERCHANTID,
							'trnCardOwner' => $_POST['cc_owner'],
							'trnCardNumber' => $_POST['cc_number'],
							'trnExpMonth' => substr($_POST['cc_expires'],0,2),
							'trnExpYear' => substr($_POST['cc_expires'],2,2),
							'trnCardCvd' => $_POST['cc_code'],
							'trnOrderNumber' => $order->info['orders_id'],
							'trnAmount' => number_format($order->info['total'], 2),
							'ordEmailAddress' => $order->customer['email_address'],
							'ordName' => $_POST['cc_owner'],
							'ordPhoneNumber' => $order->customer['telephone'],
							'ordAddress1' => $order->customer['street_address'],
							'ordAddress2' => $order->customer['street_address_2'],
							'ordCity' => $order->customer['city'],
							'ordProvince' => $this->get_zone_code($order->customer['state']),
							'ordPostalCode' => $order->customer['postcode'],
							'ordCountry' => $this->get_country_code($order->customer['country']),
							'trnType' => 'P',
							'shippingMethod' => $order->info['shipping_method'],
							'shipName' => $order->delivery['firstname'] . ' ' . $order->delivery['lastname'],
							'shipAddress1' => $order->delivery['street_address'],
							'shipAddress2' => $order->delivery['street_address_2'],
							'shipCity' => $order->delivery['city'],
							'shipProvince' => $this->get_zone_code($order->delivery['state']),
							'shipPostalCode' => $order->delivery['postcode'],
							'shipCountry' => $this->get_country_code($order->delivery['country']),
							);
		
		#echo '<pre>';	print_r($order); echo '</pre>';
		#echo '<pre>';	print_r($data_array); echo '</pre>';
		$response = http_request("https://www.beanstream.com/scripts/process_transaction.asp", $data_array);
		$response_vars = explode('&', $response);
		foreach ($response_vars as $key => $value) {
			$tmp = explode('=', $value);
			$vars[$tmp[0]] = $tmp[1];
		}
		#echo '<pre>'; print_r($vars); echo '</pre>';
		
		if ($vars['trnApproved'] != '1') {
			shop_redirect(shop_href_link('checkout_payment.php', 'error_message=' . urlencode(MODULE_PAYMENT_CC_TEXT_ERROR . ' ' . $vars['messageText']), 'SSL'));
		}
		$order->info['cc_approval'] = $vars['authCode'];
	}

	function after_process() {
	}

	function check() {
	  return defined('MODULE_PAYMENT_BEANSTREAM_STATUS');
	}

	function install() {
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_key, configuration_value) values ('MODULE_PAYMENT_BEANSTREAM_STATUS', 'true')");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Merchant ID', 'MODULE_PAYMENT_BEANSTREAM_MERCHANTID', '111111111', 'The Merchant ID used for the Beanstream.com service', '6', '0', now())");
	}

	function remove() {
	  shop_db_query("delete from " . DB_PREFIX . "configuration where configuration_key like 'MODULE_PAYMENT_BEANSTREAM_%'");
	}

	function keys() {
	  return array('MODULE_PAYMENT_BEANSTREAM_STATUS', 'MODULE_PAYMENT_BEANSTREAM_MERCHANTID');
	}
}
