<?php
/*
	eShox OS
	http://www.eshox.com/

	Copyright (c) 2003, Secure.cc, Inc.

	Released under the GNU General Public License

*/
  
  class psigate {
	var $code, $title, $description, $enabled;

	function psigate() {
	  $this->code = 'psigate';
	  $this->title = 'PSiGate';
	  $this->shop_title = MODULE_PAYMENT_CC_TEXT_TITLE;
	  $this->description = '';
	  $this->signup = 'http://www.psigate.com/';
	  $this->enabled = defined('MODULE_PAYMENT_PSIGATE_STATUS');
	  $this->recommend_level = 1;
	  $this->version = "1.0";
	}

	function javascript_validation() {
	  return shop_draw_cc_javascript_validation($this->code);
	}

	function selection() {
	  return shop_draw_cc_input();
	}

	function pre_confirmation_check() {
	  if ($_POST['payment_selected'] == $this->code) shop_validate_cc($_POST['cc_owner'],$_POST['cc_number'], $_POST['cc_expires_month'], $_POST['cc_expires_year'], $_POST['cc_code']);
	}

	function confirmation() {
	  global $checkout_form_action;

	  $checkout_form_action = 'https://order.psigate.com/psigate.asp';

	  return false;
	}

	function process_button() {
	  global $order;

	  $process_button_string = shop_draw_hidden_field('MerchantID', MODULE_PAYMENT_PSIGATE_MERCHANT_ID) . UNIX_RETURN .
	                           shop_draw_hidden_field('FullTotal', number_format($order->info['total'] * $GLOBALS['currencies']->get_value(MODULE_PAYMENT_PSIGATE_CURRENCY), 2)) . UNIX_RETURN .
	                           shop_draw_hidden_field('ThanksURL', shop_href_link('checkout_process.php', '', 'SSL')) . UNIX_RETURN .
	                           shop_draw_hidden_field('NoThanksURL', shop_href_link('checkout_payment.php', 'error_message=' . urlencode(MODULE_PAYMENT_CC_TEXT_ERROR), 'SSL')) . UNIX_RETURN .
	                           shop_draw_hidden_field('Bname', $_POST['cc_owner']) . UNIX_RETURN .
	                           shop_draw_hidden_field('Baddr1', $order->customer['street_address']) . UNIX_RETURN .
	                           shop_draw_hidden_field('Bcity', $order->customer['city']) . UNIX_RETURN .
	                           shop_draw_hidden_field('Bstate', $order->customer['state']) . UNIX_RETURN .
	                           shop_draw_hidden_field('Bzip', $order->customer['postcode']) . UNIX_RETURN .
	                           shop_draw_hidden_field('Bcountry', $order->customer['country']['iso_code_2']) . UNIX_RETURN .
	                           shop_draw_hidden_field('Phone', $order->customer['telephone']) . UNIX_RETURN .
	                           shop_draw_hidden_field('email', $order->customer['email_address']) . UNIX_RETURN .
	                           shop_draw_hidden_field('Sname', $order->delivery['firstname'] . ' ' . $order->delivery['lastname']) . UNIX_RETURN .
	                           shop_draw_hidden_field('Saddr1', $order->delivery['street_address']) . UNIX_RETURN .
	                           shop_draw_hidden_field('Scity', $order->delivery['city']) . UNIX_RETURN .
	                           shop_draw_hidden_field('Sstate', $order->delivery['state']) . UNIX_RETURN .
	                           shop_draw_hidden_field('Szip', $order->delivery['postcode']) . UNIX_RETURN .
	                           shop_draw_hidden_field('Scountry', $order->delivery['country']['iso_code_2']) . UNIX_RETURN .
	                           shop_draw_hidden_field('ChargeType', MODULE_PAYMENT_PSIGATE_TRANSACTION_TYPE) . UNIX_RETURN .
	                           shop_draw_hidden_field('Result', MODULE_PAYMENT_PSIGATE_TRANSACTION_MODE) . UNIX_RETURN .
	                           shop_draw_hidden_field('IP', $_SERVER['REMOTE_ADDR']) . UNIX_RETURN .
	                           shop_draw_hidden_field('CardNumber', $_POST['cc_number']) .
	                           shop_draw_hidden_field('ExpMonth', $_POST['cc_expires_month']) .
	                           shop_draw_hidden_field('ExpYear', $_POST['cc_expires_year']);

	  return $process_button_string;
	}

	function before_process() {
	  $order->info['cc_approval'] = $_GET['Code'];
	  return false;
	}

	function after_process() {
	  return false;
	}

	function check() {
	  return defined('MODULE_PAYMENT_PSIGATE_STATUS');
	}

	function install() {
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_key, configuration_value) values ('MODULE_PAYMENT_PSIGATE_STATUS', 'true')");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Merchant ID', 'MODULE_PAYMENT_PSIGATE_MERCHANT_ID', 'teststorewithcard', 'PSiGate merchant ID', '6', '2', now())");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Mode', 'MODULE_PAYMENT_PSIGATE_TRANSACTION_MODE', '0', '0 = Live (default)<br />1 = Always Good<br />2 = Always Duplicate<br />3 = Always Decline', '6', '3', 'shop_cfg_select_option(array(\'0\', \'1\', \'2\', \'3\'), ', now())");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Type', 'MODULE_PAYMENT_PSIGATE_TRANSACTION_TYPE', '1', '0 = Sale<br />1 = PreAuth (default)<br />2 = PostAuth', '6', '4', 'shop_cfg_select_option(array(\'0\', \'1\', \'2\'), ', now())");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Currency', 'MODULE_PAYMENT_PSIGATE_CURRENCY', 'CAD', 'The currency used to charge orders', '6', '6', 'shop_cfg_select_option(array(\'CAD\', \'USD\'), ', now())");
	}

	function remove() {
	  shop_db_query("delete from " . DB_PREFIX . "configuration where configuration_key in ('" . implode("','", $this->keys()) . "')");
	}

	function keys() {
	  return array('MODULE_PAYMENT_PSIGATE_STATUS', 'MODULE_PAYMENT_PSIGATE_MERCHANT_ID', 'MODULE_PAYMENT_PSIGATE_TRANSACTION_MODE', 'MODULE_PAYMENT_PSIGATE_TRANSACTION_TYPE', 'MODULE_PAYMENT_PSIGATE_CURRENCY');
	}
  }
