<?php

/*
  eShox 3 Commerce Solution
  http://www.eshox.com/
  
  Copyright (c) 2003, Secure.cc, Inc.

*/

class psigateV2 {
	var $code, $title, $description, $enabled;

	function psigateV2() {
	  $this->code = 'psigateV2';
	  $this->title = 'PSiGate V2';
	  $this->shop_title = MODULE_PAYMENT_CC_TEXT_TITLE;
	  $this->description = '';
	  $this->signup = '';
	  $this->enabled = defined('MODULE_PAYMENT_PSIGATEV2_STATUS');
	  $this->recommend_level = 5;
	  $this->version = "2.0";
	}

	function javascript_validation() {
	  return shop_draw_cc_javascript_validation($this->code);
	}

	function selection() {
	  return shop_draw_cc_input();
	}

	function pre_confirmation_check() {
	  if ($_POST['payment_selected'] == $this->code) shop_validate_cc($_POST['cc_owner'],$_POST['cc_number'], $_POST['cc_expires_month'], $_POST['cc_expires_year'], $_POST['cc_code']);
	}

	function confirmation() {
	}

	function process_button() {
	  $process_button_string = shop_draw_hidden_field('cc_owner', $_POST['cc_owner']) . 
	                           shop_draw_hidden_field('cc_number', $_POST['cc_number']) . 
	                           shop_draw_hidden_field('cc_code', $_POST['cc_code']) . UNIX_RETURN .
	                           shop_draw_hidden_field('cc_expires_month', $_POST['cc_expires_month']) . 
	                           shop_draw_hidden_field('cc_expires_year', substr($_POST['cc_expires_year'], -2)) . UNIX_RETURN;

	  return $process_button_string;
	}
	
	function before_process() {
		global $order;
		#print_r($order);
		
		require_once('classes/class.psigate_xml.php');

    $psi = new PsiGatePayment;
		if (MODULE_PAYMENT_PSIGATEV2_TESTMODE == 'Test') {
			$url = 'https://dev.psigate.com:7989/Messenger/XMLMessenger';
			$cardAction = '1';
		}
		else {
			$url = 'https://secure.psigate.com:7934/Messenger/XMLMessenger';
			$cardAction = '0';
		}
		$psi->setGatewayURL($url);
		$psi->setStoreID(MODULE_PAYMENT_PSIGATEV2_STOREID);
		$psi->setPassPhrase(MODULE_PAYMENT_PSIGATEV2_PASSWORD);
		$psi->setOrderID($order->info['orders_id']);
		$psi->setPaymentType('CC');
		$psi->setCardAction($cardAction); // 1 for Authorize, 0 for Immediate Charge
		$psi->setTaxTotal1(number_format($order->info['tax'], 2));
		$psi->setShipTotal(number_format($order->info['shipping_cost'], 2));
		$psi->setSubTotal(number_format($order->info['subtotal'], 2));
		$psi->setCardNumber($_POST['cc_number']);
		$psi->setCardExpMonth($_POST['cc_expires_month']); // 2-digit format
		$psi->setCardExpYear($_POST['cc_expires_year']); // 2-digit format
		$psi->setUserID($_SESSION['customer_id']);
		$psi->setBname($_POST['cc_owner']);
		$psi->setBcompany($order->customer['company']);
		$psi->setBaddress1($order->customer['street_address']);
		$psi->setBaddress2($order->customer['street_address_2']);
		$psi->setBcity($order->customer['city']);
		$psi->setBprovince($order->customer['state']);
		$psi->setBpostalCode($order->customer['postcode']);
		$psi->setBcountry($order->customer['country_code']); // 2 alpha characters
		$psi->setSname($order->delivery['firstname'] . ' ' . $order->delivery['lastname']);
		$psi->setScompany($order->delivery['company']);
		$psi->setSaddress1($order->delivery['street_address']);
		$psi->setSaddress2($order->delivery['street_address_2']);
		$psi->setScity($order->delivery['city']);
		$psi->setSprovince($order->delivery['state']);
		$psi->setSpostalCode($order->delivery['postcode']);
		$psi->setScountry($order->delivery['country']);
		$psi->setPhone($order->customer['telephone']);
		$psi->setFax($order->customer['fax']);
		$psi->setEmail($order->customer['email_address']);
		$psi->setComments(MODULE_PAYMENT_PSIGATEV2_COMMENTS);  // comments, whatever you'd like
		$psi->setCustomerIP(REMOTE_ADDR); // Customer IP address, for fraud
		if ($_POST['cc_code']!='') {
			$psi->setCardIDCode('1'); // Pass CVV code
			$psi->setCardIDNumber($_POST['cc_code']); // CVV code
		}
		//  $psi->setTestResult('A'); // Test result if you'd like to pass one.  See xml guide for more details
	
		// Send transaction data to the gateway
		$psi->doPayment();
		if (substr($psi->getTrxnReturnCode(),0,1) == 'Y') {
			$order->info['cc_approval'] = $psi->getTrxnReturnCode();
		}
		else {
			$error = $psi->getTrxnErrMsg();
			$error = explode(':', $error);
			$error_code = array_shift($error);
			$error = implode(' ', $error);
			shop_redirect(shop_href_link('checkout_payment.php', 'error_message=' . urlencode(MODULE_PAYMENT_CC_TEXT_ERROR . ' ' . $error), 'SSL'));
		}
	}

	function after_process() {
	}

	function check() {
	  return defined('MODULE_PAYMENT_PSIGATEV2_STATUS');
	}

	function install() {
		$i = 0;
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_key, configuration_value) values ('MODULE_PAYMENT_PSIGATEV2_STATUS', 'true')");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Store ID', 'MODULE_PAYMENT_PSIGATEV2_STOREID', 'noidset', 'The Store ID for the PSiGate service', '6', " . $i++ . ", now())");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Login Password', 'MODULE_PAYMENT_PSIGATEV2_PASSWORD', '', 'The PSiGate password', '6', " . $i++ . ", now())");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Mode', 'MODULE_PAYMENT_PSIGATEV2_TESTMODE', 'Test', 'Transaction mode used for processing orders', '6', " . $i++ . ", 'shop_cfg_select_option(array(\'Test\', \'Production\'), ', now())");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Store Comments', 'MODULE_PAYMENT_PSIGATEV2_COMMENTS', 'eShox online store order', 'Any comments that you would like to add to the PSiGate order', '6', " . $i++ . ", now())");
	}

	function remove() {
	  shop_db_query("delete from " . DB_PREFIX . "configuration where configuration_key like 'MODULE_PAYMENT_PSIGATEV2_%'");
	}

	function keys() {
	  return array('MODULE_PAYMENT_PSIGATEV2_STATUS', 'MODULE_PAYMENT_PSIGATEV2_STOREID', 'MODULE_PAYMENT_PSIGATEV2_PASSWORD', 'MODULE_PAYMENT_PSIGATEV2_TESTMODE', 'MODULE_PAYMENT_PSIGATEV2_COMMENTS');
	}
}
