<?php
/*
	eShox OS
	http://www.eshox.com/

	Copyright (c) 2003, Secure.cc, Inc.

	Released under the GNU General Public License

*/
  
class viaklix {
	var $code, $title, $description, $enabled;

	function viaklix() {
		$this->code = 'viaklix';
		$this->title = 'viaKLIX';
		$this->shop_title = MODULE_PAYMENT_CC_TEXT_TITLE;
		$this->description = '';
		$this->signup = 'http://www.viaklix.com/';
		$this->enabled = defined('MODULE_PAYMENT_VIAKLIX_STATUS');
		$this->recommend_level = 5;
		$this->version = "1.2";
	}

	function javascript_validation() {
		return shop_draw_cc_javascript_validation($this->code);
	}

	function selection() {
		return shop_draw_cc_input();
	}

	function pre_confirmation_check() {
		if ($_POST['payment_selected'] == $this->code) shop_validate_cc($_POST['cc_owner'],$_POST['cc_number'], $_POST['cc_expires_month'], $_POST['cc_expires_year'], $_POST['cc_code']);
	}

	function confirmation() {
	}

	function process_button() {		
		$process_button_string = shop_draw_hidden_field('cc_owner', $_POST['cc_owner']) . 
								 shop_draw_hidden_field('cc_number', $_POST['cc_number']) . 
								 shop_draw_hidden_field('cc_code', $_POST['cc_code']) . UNIX_RETURN .
								 shop_draw_hidden_field('cc_expires', $_POST['cc_expires_month'] . substr($_POST['cc_expires_year'], -2)) . UNIX_RETURN;

		return $process_button_string;
	}

	function before_process() {
		global $order;
		
		$cc_owner = strrev($_POST['cc_owner']);
		$cc_owner_firstname = strrev(substr($cc_owner, strpos($cc_owner, ' ')+1));
		$cc_owner_lastname =strrev( substr($cc_owner, 0, strpos($cc_owner, ' ')));

		$data_array = array(ssl_merchant_ID => MODULE_PAYMENT_VIAKLIX_MERCHANT_ID,
							ssl_pin => MODULE_PAYMENT_VIAKLIX_PIN,
							ssl_user_id => MODULE_PAYMENT_VIAKLIX_USER_ID,
							ssl_invoice_number => $order->info['orders_id'],
							ssl_session_id => session_id(),
							ssl_show_form => "false",
							ssl_amount => number_format($order->info['total'], 2),
							ssl_card_number => $_POST['cc_number'],
							ssl_exp_date => $_POST['cc_expires'],
							ssl_customer_code => $_SESSION['customer_id'],
							ssl_first_name => $cc_owner_firstname,
							ssl_last_name => $cc_owner_lastname,
							ssl_company => $order->customer['street_address'],
							ssl_address1 => $order->customer['street_address'],
							ssl_avs_address => $order->customer['street_address'],
							ssl_address2 => $order->customer['street_address2'],
							ssl_city => $order->customer['city'],
							ssl_state => $order->customer['state'],
							ssl_zip => $order->customer['postcode'],
							ssl_avs_zip => $order->customer['postcode'],
							ssl_country => $order->customer['country'],
							ssl_phone => $order->customer['telephone'],
							ssl_email => $order->customer['email_address'],
							ssl_transaction_type => "SALE",
							ssl_result_format => "ASCII",
							ssl_test_mode => ((MODULE_PAYMENT_VIAKLIX_TESTMODE == 'Test') ? "true" : "false"),
							ssl_description => STORE_NAME);

		if ($_POST['cc_code']) {
			$form_data['ssl_cvv2'] = "present";
			$form_data['ssl_cvv2cvc2'] = $_POST['cc_code'];
		}
	
		$response = http_request("https://www2.viaklix.com/process.asp", $data_array);
		$response_vars = split("[=,]" , $response);
		if ($response_vars[3] != 'APPROVED') {
			shop_redirect(shop_href_link('checkout_payment.php', 'error_message=' . urlencode($response_vars[3]), 'SSL', true, false));
		}
	}

	function after_process() {
	}

	function check() {
	  return defined('MODULE_PAYMENT_VIAKLIX_STATUS');
	}

	function install() {
		shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_key, configuration_value) values ('MODULE_PAYMENT_VIAKLIX_STATUS', 'true')");
		shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('viaKLIX Merchant ID', 'MODULE_PAYMENT_VIAKLIX_MERCHANT_ID', 'XYZ', '', '6', '0', now())");
		shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('viaKLIX Pin', 'MODULE_PAYMENT_VIAKLIX_PIN', '0001', '', '6', '0', now())");
		shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('viaKLIX User ID', 'MODULE_PAYMENT_VIAKLIX_USER_ID', 'auser', '', '6', '0', now())");
		shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Mode', 'MODULE_PAYMENT_VIAKLIX_TESTMODE', 'Test', 'Transaction mode used for processing orders', '6', '0', 'shop_cfg_select_option(array(\'Test\', \'Production\'), ', now())");
	}

	function remove() {
	  shop_db_query("delete from " . DB_PREFIX . "configuration where configuration_key like 'MODULE_PAYMENT_VIAKLIX_%'");
	}

	function keys() {
		return array('MODULE_PAYMENT_VIAKLIX_STATUS', 'MODULE_PAYMENT_VIAKLIX_MERCHANT_ID', 'MODULE_PAYMENT_VIAKLIX_PIN', 'MODULE_PAYMENT_VIAKLIX_USER_ID', 'MODULE_PAYMENT_VIAKLIX_TESTMODE');
	}
	}
