<?php
/*
	eShox OS
	http://www.eshox.com/

	Copyright (c) 2003, Secure.cc, Inc.

	Released under the GNU General Public License

*/

class table {
	var $code, $title, $description, $icon, $enabled, $quote;

	function table() {
		$this->code = 'table';
		$this->title = MODULE_SHIPPING_TABLE_TEXT_TITLE;
		$this->description = 'Table Rate Shipping Options:';
		$this->icon = 'images/shipping/shipping.gif';
		$this->enabled = defined('MODULE_SHIPPING_TABLE_STATUS');
		$this->quote = array();
	}

	function quote() {
		$this->table_quote = array();
		$tables = explode(',', MODULE_SHIPPING_TABLE_COST);
		$shipping_table_cost = 9999;
		foreach($tables as $table) {
			$rates = explode('=', $table);
			if (sizeof($rates) > 1) {
				$service = $rates[0];
				$table_cost = split("[:;]" , $rates[1]);
			} else {
				$service = MODULE_SHIPPING_TABLE_NAME;
				$table_cost = split("[:;]" , $rates[0]);
			}
			if (MODULE_SHIPPING_TABLE_MODE == 'price') {
				$order_total = $_SESSION['cart']->show_total();
			} else {
				$order_total = $_SESSION['cart']->show_weight();
			}

			for ($i = 0; $i < count($table_cost); $i++) {
				$j=$i*2;
				if ($order_total <= $table_cost[$j]) {
					$total = $table_cost[$j+1];
					break;
				}
			}
			
			if ($total > 0) {
				$total = $total + ($total * (SHIPPING_MARK/100));
				$total = (SHIPPING_HANDLING_TOTAL + $total);
				if ($total < $shipping_table_cost) $shipping_table_cost = $total;
				$this->quote[] = array('Method' => MODULE_SHIPPING_TABLE_TEXT_WAY, 'Service' => $service, 'TotalCharges' => $total);
			}
		}
		return $shipping_table_cost;
	}

	function check() {
	  return defined('MODULE_SHIPPING_TABLE_STATUS');
	}

	function install() {
		shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_key, configuration_value) values ('MODULE_SHIPPING_TABLE_STATUS', 'true')");
		shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Name of table shipping option', 'MODULE_SHIPPING_TABLE_NAME', 'Table Rate Shipping', 'The name of the table rate shipping option:', '6', '1', now())");
		shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Shipping Table(s)', 'MODULE_SHIPPING_TABLE_COST', '25:8.50;50:5.50;10000:0.00', 'Example table: 25:8.50;50:5.50 - up to 25 ($/lbs) charge $8.50, from there to 50 charge $5.50.', '6', '2', 'shop_cfg_textarea(', now())");
		shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Table Method', 'MODULE_SHIPPING_TABLE_MODE', 'weight', 'Is the shipping table based on the total weight or the total amount of the order?', '6', '3', 'shop_cfg_select_option(array(\'weight\', \'price\'), ', now())");
	}

	function remove() {
		shop_db_query("delete from " . DB_PREFIX . "configuration where configuration_key like 'MODULE_SHIPPING_TABLE_%'");
	}

	function keys() {
		return array('MODULE_SHIPPING_TABLE_STATUS', 'MODULE_SHIPPING_TABLE_NAME', 'MODULE_SHIPPING_TABLE_COST', 'MODULE_SHIPPING_TABLE_MODE');
	}
}